package mekanism.client.gui.element;

import codechicken.lib.vec.Rectangle4i;
import mekanism.client.gui.IGuiWrapper;
import mekanism.client.sound.SoundHandler;
import mekanism.common.tile.TileEntityDigitalMiner;
import mekanism.common.util.LangUtils;
import mekanism.common.util.MekanismUtils;
import mekanism.common.util.MekanismUtils.ResourceType;
import net.minecraft.util.ResourceLocation;

public class GuiVisualsTab extends GuiElement {
    private TileEntityDigitalMiner tileEntity;

    public GuiVisualsTab(
        IGuiWrapper gui, TileEntityDigitalMiner tile, ResourceLocation def
    ) {
        super(
            MekanismUtils.getResource(ResourceType.GUI_ELEMENT, "GuiVisualsTab.png"),
            gui,
            def
        );

        tileEntity = tile;
    }

    @Override
    public Rectangle4i getBounds(int guiWidth, int guiHeight) {
        return new Rectangle4i(guiWidth - 26, guiHeight + 6, 26, 26);
    }

    @Override
    public void renderBackground(int xAxis, int yAxis, int guiWidth, int guiHeight) {
        mc.renderEngine.bindTexture(RESOURCE);

        guiObj.drawTexturedRect(guiWidth - 26, guiHeight + 6, 0, 0, 26, 26);

        if (xAxis >= -21 && xAxis <= -3 && yAxis >= 10 && yAxis <= 28) {
            guiObj.drawTexturedRect(guiWidth - 21, guiHeight + 10, 26, 0, 18, 18);
        } else {
            guiObj.drawTexturedRect(guiWidth - 21, guiHeight + 10, 26, 18, 18, 18);
        }

        mc.renderEngine.bindTexture(defaultLocation);
    }

    @Override
    public void renderForeground(int xAxis, int yAxis) {
        mc.renderEngine.bindTexture(RESOURCE);

        if (xAxis >= -21 && xAxis <= -3 && yAxis >= 10 && yAxis <= 28) {
            displayTooltip(
                LangUtils.localize("gui.visuals") + ": "
                    + LangUtils.transOnOff(tileEntity.clientRendering),
                xAxis,
                yAxis
            );
        }

        mc.renderEngine.bindTexture(defaultLocation);
    }

    @Override
    public void preMouseClicked(int xAxis, int yAxis, int button) {}

    @Override
    public void mouseClicked(int xAxis, int yAxis, int button) {
        if (button == 0) {
            if (xAxis >= -21 && xAxis <= -3 && yAxis >= 10 && yAxis <= 28) {
                tileEntity.clientRendering = !tileEntity.clientRendering;
                SoundHandler.playSound("gui.button.press");
            }
        }
    }
}
