package mekanism.common.base;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.Container;
import net.minecraft.world.World;

public interface IGuiProvider {
    /**
     * Get the container for a GUI. Common.
     * @param ID - gui ID
     * @param player - player that opened the GUI
     * @param world - world the GUI was opened in
     * @param x - gui's x position
     * @param y - gui's y position
     * @param z - gui's z position
     * @return the Container of the GUI
     */
    public Container
    getServerGui(int ID, EntityPlayer player, World world, int x, int y, int z);

    /**
     * Get the actual interface for a GUI. Client-only.
     * @param ID - gui ID
     * @param player - player that opened the GUI
     * @param world - world the GUI was opened in
     * @param x - gui's x position
     * @param y - gui's y position
     * @param z - gui's z position
     * @return the GuiScreen of the GUI
     */
    public Object
    getClientGui(int ID, EntityPlayer player, World world, int x, int y, int z);
}
