package mekanism.common.item;

import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import mekanism.api.EnumColor;
import mekanism.common.util.LangUtils;
import net.minecraft.block.Block;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.util.IIcon;
import net.minecraft.util.StatCollector;

public class ItemBlockPlastic extends ItemBlock {
    public Block metaBlock;

    public ItemBlockPlastic(Block block) {
        super(block);
        metaBlock = block;
        setHasSubtypes(true);
    }

    @Override
    public int getMetadata(int i) {
        return i;
    }

    @Override
    public IIcon getIconFromDamage(int i) {
        return metaBlock.getIcon(2, i);
    }

    @Override
    public String getItemStackDisplayName(ItemStack stack) {
        EnumColor colour = EnumColor.DYES[stack.getItemDamage() & 15];
        String colourName;

        if (StatCollector.canTranslate(
                getUnlocalizedName(stack) + "." + colour.dyeName
            )) {
            return LangUtils.localize(getUnlocalizedName(stack) + "." + colour.dyeName);
        }

        if (colour == EnumColor.BLACK) {
            colourName = EnumColor.DARK_GREY + colour.getDyeName();
        } else {
            colourName = colour.getDyedName();
        }

        return colourName + " " + super.getItemStackDisplayName(stack);
    }

    @SideOnly(Side.CLIENT)
    public int getColorFromItemStack(ItemStack stack, int par2) {
        EnumColor colour = EnumColor.DYES[stack.getItemDamage() & 15];
        return (int) (colour.getColor(0) * 255) << 16
            | (int) (colour.getColor(1) * 255) << 8 | (int) (colour.getColor(2) * 255);
    }
}
