package mekanism.common.tile;

import java.util.Map;

import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import mekanism.api.MekanismConfig.usage;
import mekanism.common.block.BlockMachine.MachineType;
import mekanism.common.recipe.RecipeHandler.Recipe;
import mekanism.common.recipe.machines.EnrichmentRecipe;

public class TileEntityEnrichmentChamber
    extends TileEntityElectricMachine<EnrichmentRecipe> {
    public TileEntityEnrichmentChamber() {
        super(
            "enrichment",
            "EnrichmentChamber",
            usage.enrichmentChamberUsage,
            200,
            MachineType.ENRICHMENT_CHAMBER.baseEnergy
        );
    }

    @Override
    public Map getRecipes() {
        return Recipe.ENRICHMENT_CHAMBER.get();
    }

    @Override
    @SideOnly(Side.CLIENT)
    public float getVolume() {
        return 0.3F * super.getVolume();
    }
}
